<%@ page import="java.util.*,java.io.*,java.text.SimpleDateFormat,java.net.URL"%>


<%!

  // ---------------------------------------------------------------------------------------------------
  // -- CUSTOMIZATION SECTION - USE THESE FIELDS TO CUSTOMIZE YOUR GUEST BOOK  -------------------------
  // ---------------------------------------------------------------------------------------------------
  
  public static final String DEFAULT_LANG = "us";
  // This field indicates the directory in which the JSP will store its messages.
  // ALL the messages are stored in a single "guestBook.jsp" file.
  public static final String DIR = "C:\\";
  
  // This field represents the format in which the dates are going to be displayed
  //public static final String DATE_FORMAT = "EEE, d MMM yyyy HH:mm:ss Z";
  public static final String DATE_FORMAT = "EEE, d MMM yyyy";

  // email of the administrator of the site. Set NULL if you don't want this email to appear on the page.
  public static final String ADMIN_EMAIL = null;

  // password for the administrator
  public static final String ADMIN_PWD = "foo";
  
  // email for the administrator (where notifications of new messages are being sent). Leave null for no notification
  public static final String ADMIN_NOTIFICATION_EMAIL = null;
  
  // smtp server that is going to be used to send the notification emails. Leave null for no notification
  public static final String SMTP_SERVER = "my.smtp.server.com";
  
  // subject to be used in the notification emails. Leave null for no notification
  public static final String NOTIFICATION_EMAIL_SUBJECT = "New guest book entry";
  
  // If true, all new entries to the guest book are going to be visible to everybody.
  // If false, new entries have to be approved by the admin in order to be visible.
  public static final boolean AUTO_APPROVE_MESSAGES = true;

  public static final int PAGE_SIZE = 10000;
  // ---------------------------------------------------------------------------------------------------
  // -- END OF CUSTOMIZATION SECTION  ------------------------------------------------------------------
  // ---------------------------------------------------------------------------------------------------
%>

<%
  response.setHeader("Cache-Control", "no-cache");
  response.setHeader("Pragma", "no-cache");

%>

<%!

  public static final int ERR_BAD_MAIL = 100;
  public static final int ERR_BAD_LOCATION = 101;
  public static final int ERR_BAD_NAME = 102;
  public static final int ERR_BAD_WEBSITE = 103;
  public static final int ERR_BAD_MESSAGE = 104;

  public static final int FIELD_MAIL = 0;
  public static final int FIELD_LOCATION = 1;
  public static final int FIELD_NAME = 2;
  public static final int FIELD_WEBSITE = 3;

  public static final int MSG_ADDCOMMENT = 200;
  public static final int MSG_BACKTOGB = 201;
  public static final int MSG_MSG_RECEIVED = 202;
  public static final int MSG_LANGNAME = 203;
  public static final int MSG_TITLE = 204;
  public static final int MSG_NOHTML = 205;
  
  public static final String separator = "\"";
  
  public static Hashtable messagesDB;

  public static final Object LOCK = new Object();
  public static final String internalDateFormat = "yyMMddHHmmssZ"; 

  public static File messagesFile;
  public static boolean initialized;
  public static Throwable initError;
  static {
    try {
      messagesFile = new File(DIR+"guestBook.txt").getAbsoluteFile();
      if (!messagesFile.exists()) messagesFile.createNewFile();
      initEntryCounter();
      
      messagesDB = new Hashtable();
      Hashtable usLang = new Hashtable();
      messagesDB.put("us",usLang);
      usLang.put(new Integer(0),     "e-mail");
      usLang.put(new Integer(1),     "Country");
      usLang.put(new Integer(2),     "Name");
      usLang.put(new Integer(3),     "Website");
      usLang.put(new Integer(100),   "Your email doesn't seem valid...");
      usLang.put(new Integer(101),   "Please enter a location in the Country field.");
      usLang.put(new Integer(102),   "Please enter a name describing who you are (Must be at least 4 chars long).");
      usLang.put(new Integer(103),   "Either enter a valid website as your website or leave the field blank.");
      usLang.put(new Integer(104),   "You didn't enter any comment !");
      usLang.put(new Integer(200),   "Write in the guest book");
      usLang.put(new Integer(201),   "Back to guest book");
      usLang.put(new Integer(202),   "Your message has been submitted.<BR>The administrator has to review it before it is visible for anyone.");
      usLang.put(new Integer(203),   "English");
      usLang.put(new Integer(204),   "The Guest Book");
      usLang.put(new Integer(205),   "* No HTML is allowed");
      Hashtable frLang = new Hashtable();
      messagesDB.put("fr",frLang);
      frLang.put(new Integer(0),     "e-mail");
      frLang.put(new Integer(1),     "Pays");
      frLang.put(new Integer(2),     "Nom");
      frLang.put(new Integer(3),     "Site Ouebe");
      frLang.put(new Integer(100),   "Votre eMail ne semble pas valide...");
      frLang.put(new Integer(101),   "S'il vous plait, entrez une location dans la case Pays.");
      frLang.put(new Integer(102),   "S'il vous plait, entrez un nom vous decrivant (au moins 4 caracteres).");
      frLang.put(new Integer(103),   "Entrez un site ouebe valide ou n'entrez rien dans la section 'Site ouebe'.");
      frLang.put(new Integer(104),   "Vous n'avez pas entr&eacute; de commentaire !");
      frLang.put(new Integer(200),   "Ecrire dans le livre d'or");
      frLang.put(new Integer(201),   "Revenir au livre d'or");
      frLang.put(new Integer(202),   "Votre message a &eacute;t&eacute; enregistr&eacute;.<BR>L'administrateur devra l'accepter avant qu'il soit visible par tout le monde.");
      frLang.put(new Integer(203),   "Fran&ccedil;ais");
      frLang.put(new Integer(204),   "Le Livre d'Or");
      frLang.put(new Integer(205),   "* HTML interdit");
      
      initialized = true;
    } catch (Exception e) {
      initError = e;
      initialized = false;
    }
  }
  
  public static int entryCounter;
  public static void initEntryCounter() throws Exception {
    entryCounter = 0;
    FileReader fr = null;
    Exception ex;
    try {
      BufferedReader in = new BufferedReader(fr=new FileReader(messagesFile));
      while (true) {
        String line = in.readLine();
        if (line==null) return;
        int entryid = Integer.parseInt(line.substring(0,line.indexOf(separator)));
        entryCounter = Math.max(entryCounter,entryid);
      }
    } catch (Exception e) {
      ex=e;
    }
    finally {
      if (fr!=null) try { fr.close(); } catch (Exception e) {}
    }
  }
  
  public static final String getMessage(int num, UserStatus ust) {
    Hashtable lang = (Hashtable)messagesDB.get(ust.curLang);
    if (lang==null) return "Unknown lang: " + ust.curLang;
    String msg = (String) lang.get(new Integer(num));
    if (msg==null) return "Unknown msg " + num + " for lang " + ust.curLang;
    return msg;
  }
  
  public static String replace(String str, String oldValue, String newValue) {
    int index = str.indexOf(oldValue);

    if (index == -1)
      return str;
    else {
      int oldValueLen = oldValue.length();
      int indexRemaining = 0;
      StringBuffer result = new StringBuffer();

      while (index != -1) {
        result.append(str.substring(indexRemaining, index));
        result.append(newValue);
        index = str.indexOf(oldValue, indexRemaining = index + oldValueLen);
      }
      result.append(str.substring(indexRemaining));
      return result.toString();
    }
  }


  /**
   *  returns an HTML-valid version of this String. (ie: all specials characters
   *  like &amp;, &lt;... are replaced by their corresponding HTML entities)
   *
   * @param  arg  The String to be processed
   * @return      The valid HTML String.
   */
  public static String formatForHTML(String arg) {
    if (arg == null)
      return "";
    return replace(replace(replace(replace(arg, "&", "&amp;"), "\"", "&quot;"), ">", "&gt;"), "<", "&lt;");
  }


  /**
   *  returns an JavaScript-valid version of this String. (ie: all specials
   *  characters like &quot;, \... are replaced by their corresponding
   *  Javascript String syntax equivalent)
   *
   * @param  arg  Description of the Parameter
   * @return      Description of the Return Value
   */
  public static String formatForJavascriptString(String arg) {
    if (arg == null)
      return "";
    return replace(replace(replace(replace(replace(arg, "\\", "\\\\"), "\r", "\\r"), "\n", "\\n"), "\"", "\\\""), "'", "\\'");
  }
  
  
  public static String formatForEntry(String arg) {
    if (arg == null)
      return "";
    return replace(replace(arg, "\r", " "), "\n", "<BR>");
  }

  private class Entry {
    private String name, email, website, location, text;
    public boolean checked;
    public int id;
    private Date date;
    
    public boolean equals(Object o) {
      if (o instanceof Entry) {
        Entry e = (Entry)o;
        return name.equals(e.name) &&
               email.equals(e.email) &&
               website.equals(e.website) &&
               location.equals(e.location) &&
               text.equals(e.text) &&
               date.equals(e.date) && 
               (id == e.id);
      }
      return false;
    }
    
    public Entry(String a_name, String a_email, String a_website, String a_location, String a_text, UserStatus ust) {
      
      if (a_name.length() > 50) a_name = a_name.substring(0,50);
      if (a_name.trim().length()<4) throw new IllegalArgumentException(getMessage(ERR_BAD_NAME,ust));
      a_name = formatForHTML(a_name.trim());
      
      int arobas;
      if (a_email.trim().length()>0) {
        if ((arobas=a_email.indexOf("@"))<2) throw new IllegalArgumentException(getMessage(ERR_BAD_MAIL,ust));
        if ((arobas=a_email.indexOf(".",arobas))<1) throw new IllegalArgumentException(getMessage(ERR_BAD_MAIL,ust));
      }
      a_email = formatForHTML(a_email.trim());
      
      if (a_website.trim().equals("http://")) a_website = "";
      if (a_website.trim().length()>0) {
        try {
          URL u = new URL(a_website.trim());
        } catch (Exception e) {
          throw new IllegalArgumentException(getMessage(ERR_BAD_WEBSITE,ust));
        }
      }
      a_website = formatForHTML(a_website.trim());

      if (a_location.trim().length()<3) throw new IllegalArgumentException(getMessage(ERR_BAD_LOCATION,ust));
      a_location = formatForHTML(a_location.trim());
      
      if (a_text.trim().length()<4) throw new IllegalArgumentException(getMessage(ERR_BAD_MESSAGE,ust));
      a_text = formatForEntry(formatForHTML(a_text.trim()));


      name = a_name;
      email = a_email;
      website = a_website;
      location = a_location;
      text = a_text;
      date = new Date();
    }
    
    public Entry(String serializedForm) {
      try {
        StringTokenizer stw = new StringTokenizer(serializedForm,separator);
        id = Integer.parseInt(stw.nextToken());
        checked = stw.nextToken().trim().equals("true");
        date = new SimpleDateFormat(internalDateFormat).parse(stw.nextToken().trim());
        name = stw.nextToken().trim();
        email = stw.nextToken().trim();
        website = stw.nextToken().trim();
        location = stw.nextToken().trim();
        text = stw.nextToken().trim();
      } catch (Exception e) {
        throw new IllegalArgumentException(e.getMessage());
      }
    }
    
    public String getSerializedForm() {
      return 
        id + separator + ((checked) ? "true" : "false") + separator +
        new SimpleDateFormat(internalDateFormat).format(date) + " "+separator+" " +
        name + " "+separator+" " + email + " "+separator+" " + website + " "+separator+" " + location + " "+separator+" " + text ; 
    }
    
    public String getHTML(boolean admin) {
      return 
        "<DIV class=\"entryoutbound\"><TABLE class=\"entry\" cellpadding=0 cellspacing=0><TR class=\"" + ((checked)?"msgheader":"untrustedmsgheader") + "\">" +
        "<TD class=\"msgowner\">" + name + 
        "</TD><TD class=\"msgemail\">" + ((email.length()==0) ? "" : "<A HREF=\"mailto:"+email+"\">" + email + "</A>") + 
        "</TD><TD class=\"msgwebsite\">" + ((website.length()==0) ? "" : "<A HREF=\""+website+"\">" + website + "</A>") + 
        "</TD><TD class=\"msglocation\">" + location +
        ((admin && (!checked)) ? "</TD><TD><A HREF=\"guestBook.jsp?accept="+id+"\">Accept</A>" : "") +
        ((admin) ? "</TD><TD><A HREF=\"guestBook.jsp?delete="+id+"\">Delete</A>" : "") +
        "</TD><TD class=\"msgdate\">" + new SimpleDateFormat(DATE_FORMAT).format(date) + 
        "</TD></TR><TR><TD colspan=\"20\" class=\"msgbody\">" + text +
        "</TD></TR></TABLE></DIV>"; 
    }
  }
  
  private class UserStatus {
    public int page;
    public int pageSize = PAGE_SIZE;
    public Entry currentMsg;
    public boolean admin = false;
    public String curLang = DEFAULT_LANG;
  }
  
  private class EntriesPage {
    public int pageNum;
    public int totalPage;
    public int pageSize;
    public ArrayList data = new ArrayList();
    public String getHTML(boolean admin) {
      StringBuffer sbf = new StringBuffer();
      for (int i=0 ; i<data.size() ; i++) {
        Entry e = (Entry)data.get(i);
        sbf.append(e.getHTML(admin)).append("\r\n");
        
      }
      return sbf.toString();
    }
  }
  
  
  public EntriesPage loadEntries(UserStatus status) {
    synchronized(LOCK) {
      FileReader fr=null;
      try {
        EntriesPage res = new EntriesPage();
        BufferedReader in = new BufferedReader(fr=new FileReader(messagesFile));
        for (int l = 0 ; l<status.pageSize ; l++) {
          String line = in.readLine();
          if (line==null) return res;
          Entry entry = new Entry(line);
          if (entry.checked || status.admin)
            res.data.add(entry);
        }
          
        return res;
      } catch (Exception e) {
        e.printStackTrace();
        return null;
      }
      finally {
        if (fr!=null) try { fr.close(); } catch (Exception e) {}
      }
    }
  }
  public void writeEntry(Entry e) {
    synchronized(LOCK) {
      FileWriter fw=null;
      try {
          BufferedWriter out = new BufferedWriter(fw=new FileWriter(messagesFile,true));
          e.id = ++entryCounter;
          out.write(e.getSerializedForm());
          out.newLine();
          out.flush();
      } catch (Exception ex) {
        ex.printStackTrace();
        return;
      }
      finally {
        if (fw!=null) try { fw.flush(); fw.close(); } catch (Exception ex) {}
      }
    }
  }
  public void deleteEntry(int entryID) {
    synchronized(LOCK) {
      FileReader fr=null;
      FileWriter fw=null;
      try {
        File tempFile;
        BufferedReader in = new BufferedReader(fr=new FileReader(messagesFile));
        BufferedWriter out = new BufferedWriter(fw=new FileWriter(tempFile=new File(messagesFile.getCanonicalPath()+".tmp")));
        while (true) {
          String line = in.readLine();
          if (line==null) break ;
          Entry entry = new Entry(line);
          if (entry.id != entryID) {
            out.write(entry.getSerializedForm());
            out.newLine();
          }
        }
        out.flush();
        fr.close();
        fw.close();
        
        messagesFile.delete();
        tempFile.renameTo(messagesFile);
      } catch (Exception e) {
        e.printStackTrace();
        return;
      }
      finally {
        if (fr!=null) try { fr.close(); } catch (Exception e) {}
        if (fw!=null) try { fw.close(); } catch (Exception e) {}
      }
    }
  }
  public void acceptEntry(int entryID) {
    synchronized(LOCK) {
      FileReader fr=null;
      FileWriter fw=null;
      try {
        File tempFile;
        BufferedReader in = new BufferedReader(fr=new FileReader(messagesFile));
        BufferedWriter out = new BufferedWriter(fw=new FileWriter(tempFile=new File(messagesFile.getCanonicalPath()+".tmp")));
        while (true) {
          String line = in.readLine();
          if (line==null) break ;
          Entry entry = new Entry(line);
          if (entry.id == entryID) entry.checked = true;
          out.write(entry.getSerializedForm());
          out.newLine();
        }
        out.flush();
        fr.close();
        fw.close();
        
        messagesFile.delete();
        tempFile.renameTo(messagesFile);
      } catch (Exception e) {
        e.printStackTrace();
        return;
      }
      finally {
        if (fr!=null) try { fr.close(); } catch (Exception e) {}
        if (fw!=null) try { fw.close(); } catch (Exception e) {}
      }
    }
  }
  
  
  public class SendMail implements Runnable{
    String mailBody;
    public SendMail(Entry e, HttpServletRequest req) {
      StringBuffer body = new StringBuffer();
      body.append("A new message has been posted. Please log into the guest book to approve of delete it (");
      body.append(req.getRequestURL());
      body.append(").\r\n\r\n");
      body.append("From     : ").append(req.getRemoteAddr()).append(" (").append(req.getRemoteHost()).append(")\r\n");
      body.append("Name     : ").append(e.name).append("\r\n");
      body.append("Website  : ").append(e.website).append("\r\n");
      body.append("Email    : ").append(e.email).append("\r\n");
      body.append("Location : ").append(e.location).append("\r\n");
      body.append("Content  : ").append(replace(e.text,"<BR>","\r\n")).append("\r\n");
      mailBody = body.toString();
      Thread t = new Thread(this);
      t.start();
    }
    
    public void run() {
      try {
        //Get system properties
        Properties props = System.getProperties();
        
        //Specify the desired SMTP server
        props.put("mail.smtp.host", SMTP_SERVER);
        
        // create a new Session object
        javax.mail.Session session = javax.mail.Session.getInstance(props,null);
        
        // create a new MimeMessage object (using the Session created above)
        javax.mail.Message message = new javax.mail.internet.MimeMessage(session);
        message.setFrom(new javax.mail.internet.InternetAddress(ADMIN_NOTIFICATION_EMAIL));
        message.setRecipients(javax.mail.Message.RecipientType.TO, new javax.mail.internet.InternetAddress[] { new javax.mail.internet.InternetAddress(ADMIN_NOTIFICATION_EMAIL) });
        message.setSubject(NOTIFICATION_EMAIL_SUBJECT);
        message.setContent(mailBody, "text/plain");
        
        javax.mail.Transport.send(message);
      } catch (Exception t) {
        t.printStackTrace();
      }
    }
  }
  public void sendMail(Entry e, HttpServletRequest req) {
    try {
      if (ADMIN_NOTIFICATION_EMAIL==null) return;
      if (NOTIFICATION_EMAIL_SUBJECT==null) return;
      if (SMTP_SERVER==null) return;
      new SendMail(e,req);
    } catch (Exception t) {
      t.printStackTrace();
    }

  }
%>
<%

  // Creating/retrieving the session object
  UserStatus userStatus = null;
  try {
    userStatus = (UserStatus)session.getAttribute("USER_CFG");
  } catch (Exception e) {}
  if (userStatus == null) {
    userStatus = new UserStatus();
    session.setAttribute("USER_CFG",userStatus);
  }
  // Looking for an admin login
  String adminPwd = request.getParameter("admin");
  if (adminPwd!=null)
  if (adminPwd.equals(ADMIN_PWD)) userStatus.admin=true;
  
  String defL = request.getParameter("lang");
  if (defL!=null)
  if (messagesDB.containsKey(defL)) {
    userStatus.curLang=defL;
  }
  
  String add = request.getParameter("add");
  boolean addingComment=false;
  String errorMessage = null;
  if (add!=null)
  if (add.equals("true")) {
    addingComment = true;
  }
  
  
  String name="",email="",website="http://",location="",text="";
  String submitted=request.getParameter("addEntry");
  String toAlert = null;
  if (submitted!=null) {
    name = request.getParameter("name");
    email = request.getParameter("email");
    website = request.getParameter("website");
    location = request.getParameter("location");
    text = request.getParameter("text");
    Entry e = null;
    try {
      e = new Entry(name,email,website,location,text,userStatus);
    } catch (IllegalArgumentException ex) {
      addingComment=true;
      errorMessage = ex.getMessage();
    }
    if (e!=null) {
      boolean autoCheck = AUTO_APPROVE_MESSAGES;
      e.checked = autoCheck;
      writeEntry(e);
      if (!userStatus.admin) sendMail(e,request);
      if (!autoCheck) toAlert = getMessage(MSG_MSG_RECEIVED,userStatus);
    }
  }
  
  if (userStatus.admin) {
    String deleteID = request.getParameter("delete");
    String acceptID = request.getParameter("accept");
    try {
      if (deleteID!=null) {
        int id = Integer.parseInt(deleteID);
        deleteEntry(id);
      }
      if (acceptID!=null) {
        int id = Integer.parseInt(acceptID);
        acceptEntry(id);
      }
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
  
%>


<HTML>
<HEAD>
<TITLE><%=getMessage(MSG_TITLE,userStatus)%></TITLE>
<link rel="stylesheet" href="guestBook.css?"/>
</HEAD>
<BODY>
<%
  if (initialized) {
%>

<%
  if (!userStatus.admin) {
%>
  <TABLE align="right"><TR><TD><FORM ACTION="guestBook.jsp" METHOD="POST"><INPUT TYPE="PASSWORD" NAME="admin" class="pwdbox"/></TD><TD><INPUT TYPE="Submit" value="Go" class="pwdbtn"/></TD></TR></FORM></TABLE>
<% 
  }
%>
<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0>
<TR>
<%
  for (Enumeration langs = messagesDB.keys();langs.hasMoreElements();) {
    String lc = (String)langs.nextElement();
    Hashtable lh = (Hashtable)messagesDB.get(lc);
    String langDesc = (String)lh.get(new Integer(MSG_LANGNAME));
    boolean isDef = userStatus.curLang.equals(lc);
    out.write("<TD class=\""+((isDef)?"deflang":"lang")+"\">");
    out.write("<A HREF=\"guestBook.jsp?lang=" + lc);
    out.write((addingComment==true) ? "&add=true" : "");
    out.write("\">");
    out.write(langDesc);
    out.write("</A>");
    out.write("</TD>");
  }
%>
</TR></TABLE>
<P class="title"><%=getMessage(MSG_TITLE,userStatus)%><%if (userStatus.admin) out.write(" - Admin!");%></P>
<%
  if (toAlert!=null) {
%>
<P><%=toAlert%></P>
<%
  }
%>

<%
    if (addingComment) {
%>
  <P class="error"><%=(errorMessage!=null) ? errorMessage : ""%></P>
  <FORM NAME="comment" method="POST" action="guestBook.jsp">
    <TABLE align="center">
      <TR><TD colspan="2" align="right"><%=getMessage(FIELD_NAME,userStatus)%>: <input class="inputbox" type=text name="name" value="<%=formatForHTML(name)%>"></TD>
      <TR><TD colspan="2" align="right"><%=getMessage(FIELD_MAIL,userStatus)%>: <input class="inputbox" type=text name="email" value="<%=formatForHTML(email)%>"></TD>
      <TR><TD colspan="2" align="right"><%=getMessage(FIELD_WEBSITE,userStatus)%>: <input class="inputbox" type=text name="website" value="<%=formatForHTML(website)%>"></TD>
      <TR><TD colspan="2" align="right"><%=getMessage(FIELD_LOCATION,userStatus)%>: <input class="inputbox" type=text name="location" value="<%=formatForHTML(location)%>"><BR>(France, California, ...)<SPAN style="width:200px">&nbsp;</SPAN></TD>
      <TR><TD colspan="2" align="right"><textarea name="text"><%=formatForHTML(text)%></textarea><BR><%=getMessage(MSG_NOHTML,userStatus)%></TD>
      <TR><TD><input type="submit" value="Submit" name="addEntry"></TD><TD align="right"><A HREF="guestBook.jsp"><%=getMessage(MSG_BACKTOGB,userStatus)%></A></TD>
    </TABLE>
  </FORM>
<%
    } else { // NOT adding a comment
%>
<A HREF="guestBook.jsp?add=true"><%=getMessage(MSG_ADDCOMMENT,userStatus)%></A>
<%=loadEntries(userStatus).getHTML(userStatus.admin)%>
<%
    }
  } else { // NOT initialized
%>
  There was a problem initializing the Guest Book. Please <%if (ADMIN_EMAIL!=null) out.write("<A HREF='mailto:"+ADMIN_EMAIL+"'>");%>contact the administrator<%if (ADMIN_EMAIL!=null) out.write("</A>");%> or try again later.
  <BR>
  Un probleme est survenu lors de l'initialisation du livre d'or. <%if (ADMIN_EMAIL!=null) out.write("<A HREF='mailto:"+ADMIN_EMAIL+"'>");%>Contactez l'administrateur du site<%if (ADMIN_EMAIL!=null) out.write("</A>");%> ou essayez plus tard.
<%
  } // NOT initialized END
%>
</BODY>
</HTML>